import java.applet.*;
import java.awt.*;

public class AppletNoiseFlight extends Applet implements Runnable
{
	/** foCX */
	protected DeviceController device;
	/** C̕`搧 */
	protected RenderNF render;
	/** }bvC[W */
	protected MapImage map;
	/** }bṽTlC */
	protected PixelBuffer32 thumb;

	/**  */
	public void init()
	{
		device = new DeviceController((Component)this, (Runnable)this, 31);
		render = new RenderNF(new PixelBuffer32(this, device.getWidth(), device.getHeight(), device.getWidth()));
		map = new MapImage();
		thumb = map.createThumb();
		render.viewX = 1024 << 16;
		render.viewY = 1536 << 16;
		render.viewZ = 16 << 16;
		render.setViewAngleX(0);
		device.start();
	}

	/** Jn */
	public void start()
	{
		setVisible(true);
		requestFocus();
	}

	/** j(C[v̒~) */
	public void destroy()
	{
		device.stop();
	}

	/** `v */
	public void paint(Graphics gr)
	{
		draw(gr, false);
	}

	/** C[v */
	public void run()
	{
		int indexDemo = 0;
		int speed = 0;
		while(device.isRunning())
		{
			// 
			render.setViewAngleX((render.viewA + device.getMouseX() - render.width/2) & 0xffff);
			// 
			if(device.isMousePress(3))
			{
				if(speed > 0x80)speed -= 32;
				speed -= 16;
				if(speed < -0x100)speed = -0x100;
			}else if(device.isMousePress(0))
			{
				if(speed < 0x400)speed += 16;
			}else
			{
				if(speed > 0x80)speed -= 8;
				if(speed < 0x80)speed += 8;
			}
			// Oֈړ
			render.viewX += (render.viewU*speed)>>8;
			render.viewY += (render.viewV*speed)>>8;
			// xύX
			render.viewZ = (render.height - device.getMouseY())*65536/render.height*32 + 0x40000;
			if(render.viewZ < 0x40000)render.viewZ = 0x40000;
			// `
			render.rendGround(map);
			render.rendMapThumb(thumb);
			repaint();
			// EFCg
			device.standby();
			while(!device.isFocus() && device.isRunning())device.standby();
		}
	}

	/** `obt@Avbgɏo */
	protected synchronized void draw(Graphics gr, boolean bUpdatePixelBuffer)
	{
		if(render != null && render.tx != null && render.tx.im != null)
		{
			if(bUpdatePixelBuffer)
			{
				Thread.yield();
				render.tx.update();
			}
			Thread.yield();
			gr.drawImage(render.tx.im, 0, 0, null);
			Thread.yield();
		}
	}

	/** AvbgŜ𑦍ɍĕ` */
	public void repaint()
	{
		Graphics gr;
		gr = getGraphics();
		if(gr != null)
		{
			draw(gr, true);
			gr.dispose();
		}
	}
}
