import java.awt.*;
import java.awt.event.*;

/**
 * L[{[hA}EXAsx̐܂B
 */
public class DeviceController implements Runnable, FocusListener, MouseListener,MouseMotionListener
{
	/** L[R[hQƗp */
	public static KeyEvent keyCode;
	/** eNXւ̃R|[lg */
	private Component componentParent;
	/** eNXւ̃C^[tFCX */
	private Runnable runnableParent;
	/** CXbh */
	private volatile Thread thMain;
	/** TuXbh */
	private volatile Thread thSub;
	/** notify𔭍sԊu */
	private int interval;
	/** OFPSZo */
	private long timeLast;
	/** timeLastO1bԂFPSl */
	private int fps;
	/** timeLastɌĂяoꂽstandby()̉ */
	private int countStandby;
	/** standby()ɔsꂽnotifỷ */
	private volatile int countNotify; 
	/** L[e[u */
	private boolean btable[]=new boolean[4];
	/** tH[JX𓾂Ă */
	private boolean bFocus;
	/** }EXR|[lgɂ */
	private boolean bMouseEnter;
	/** }EXXW */
	private int mouseX;
	/** }EXYW */
	private int mouseY;

	/** \z */
	public DeviceController(Component component, Runnable runnable, int interval)
	{
		this.componentParent = component;
		this.runnableParent = runnable;
		componentParent.addFocusListener(this);
		componentParent.addMouseListener(this);
		componentParent.addMouseMotionListener(this);
		mouseX = componentParent.getSize().width  / 2; 
		mouseY = componentParent.getSize().height / 2; 
		bFocus = true;
		this.interval = interval;
		fps = 1000 / interval;
		componentParent.requestFocus();
	}

	/** Xbh쐬A[vJn */
	public void start()
	{
		thMain = new Thread(this);
		thSub = new Thread(this);
		try{
			thSub.setPriority(thSub.NORM_PRIORITY+1);
		}catch(SecurityException exception){}
		thSub.start();
		thMain.start();
	}

	/** Xbh̒~v */
	public synchronized void stop()
	{
		thMain = null;
		thSub = null;
		notifyAll();
	}

	/** Xbh~ׂǂԂ */
	public boolean isRunning()
	{
		return Thread.currentThread() == thMain;
	}

	/** [v */
	public void run()
	{
		Thread th = Thread.currentThread();
		if(th == thMain)
		{
			runnableParent.run();
		}else
		{
			while(thSub == th)
			{
				try
				{
					synchronized(this)
					{
						this.wait(interval);
						countNotify++;
						notify();
					}
				}catch(InterruptedException exception){};
			}
		}
	}

	/** 1t[̏IEFCgƂČĂяo */
	public synchronized int standby()
	{
		int result;
		// FPSlZo
		long timeNow;
		timeNow = System.currentTimeMillis();
		if(timeNow/1000 != timeLast/1000)
		{
			timeLast = timeNow;
			fps = countStandby;
			if(fps == 0)fps = 1;
			countStandby = 0;
		}
		countStandby++;
		// notify()s܂ő҂
		result = countNotify;
		countNotify = 0;
		try
		{
			if(!isRunning())return result;
			this.wait();
			if(!isRunning())return result;
			this.wait(1);
		}catch(InterruptedException exception){};
		return result;
	}

	/** FPSl擾 */
	public int getFPS()
	{
		return fps;
	}

	/** tH[JX𓾂Ă邩Ԃ */
	public boolean isFocus()
	{
		return bFocus;
	}

	/** }EX{^Ă邩Ԃ(indexButton:1`3) */
	public boolean isMousePress(int indexButton)
	{
		if(indexButton == 1)return btable[1];
		if(indexButton == 2)return btable[2];
		if(indexButton == 3)return btable[3];
		return btable[0];
	}

	/** }EXR|[lgɂ邩擾 */
	public boolean isMouseEnter()
	{
		return bMouseEnter;
	}

	/** }EX݂̌XW擾 */
	public int getMouseX()
	{
		return mouseX;
	}

	/** }EX݂̌YW擾 */
	public int getMouseY()
	{
		return mouseY;
	}

	/** R|[lg̉擾 */
	public int getWidth()
	{
		return componentParent.getSize().width;
	}

	/** R|[lg̏c擾 */
	public int getHeight()
	{
		return componentParent.getSize().height;
	}

	public void focusGained(FocusEvent event)
	{
		bFocus = true;
	}

	public void focusLost(FocusEvent event)
	{
		int n;
		for(n=0; n<4; n++)
		{
			btable[n] = false;
		}
		bFocus = false;
	}

	public void mouseClicked(MouseEvent event){}
	public void mousePressed(MouseEvent event)
	{
		int modifiers;
		modifiers = event.getModifiers();
		if( (modifiers & event.BUTTON1_MASK) != 0)btable[1] = true;
		if( (modifiers & event.BUTTON2_MASK) != 0)btable[2] = true;
		if( (modifiers & event.BUTTON3_MASK) != 0)btable[3] = true;
		btable[0] = true;
		componentParent.requestFocus();
	}
	public void mouseReleased(MouseEvent event)
	{
		int modifiers;
		modifiers = event.getModifiers();
		if( (modifiers & event.BUTTON1_MASK) != 0)btable[1] = false;
		if( (modifiers & event.BUTTON2_MASK) != 0)btable[2] = false;
		if( (modifiers & event.BUTTON3_MASK) != 0)btable[3] = false;
		btable[0] = false;
		componentParent.requestFocus();
	}
	public void mouseEntered(MouseEvent event){bMouseEnter = true;}
	public void mouseExited (MouseEvent event){bMouseEnter = false;}
	public void mouseDragged(MouseEvent event){mouseX = event.getX(); mouseY = event.getY();}
	public void mouseMoved  (MouseEvent event){mouseX = event.getX(); mouseY = event.getY();}
}
