import java.applet.*;
import java.awt.*;
import java.awt.image.*;

/**
 * java.awt.Image ̑փNXB<br>
 * sNZf[^int^zƂĕێB<br>
 * `obt@ƂĊmۂꍇAjava.awt.image.MemoryImageSourceʂjava.awt.ImagełAʂjava.awt.Componentɕ\łB
 */

public class PixelBuffer32
{
	/** ʖ */
	public String name;
	/** C[W̃sNZf[^ */
	public int px[];
	/** C[W̕ */
	public int width = 32;
	/** C[W̍ */
	public int height = 32;
	/** C[W ̂ꍇnull */
	public Image im;
	/** C[W\[X ̂ꍇnull */
	public MemoryImageSource mi;
	/** `\̃R|[lg ꍇnull */
	public Component component;
	/** ߏ̂C[W */
	public boolean bTransparent;
	/** Lȃobt@ */
	public boolean bEnable;

	/** TCYw肵āA`obt@sNZz\z */
	public PixelBuffer32(Component component, int width, int height, int reserve)
	{
		this.width = width;
		this.height = height;
		this.component = component;
		px = new int[width*height+reserve];
		if(px != null)bEnable = true;
		if(component != null)
		{
			DirectColorModel staticColorModel = new DirectColorModel(32,0xff0000,0x00ff00,0x0000ff);
			mi = new MemoryImageSource(width, height, staticColorModel, px, 0, width);
			mi.setAnimated(true);
			im = component.createImage(mi);
			name = "MemoryImageSource";
		}else
		{
			name = "PureBuffer";
		}
	}

	/** 񕶎Ԃ */
	public String toString()
	{
		String name;
		if(this.name == null){ name="null"; }else{ name=this.name; }
		return "PixelBuffer32([" +name+ "], "+ width +", "+ height +")"; 
	}

	/** C[WsNZz\z */
	private boolean create(Image im)
	{
		boolean result = true;
		int n, size;
		MediaTracker tracker;
		tracker = new MediaTracker(component);
		try
		{
			tracker.addImage(im, 0);
			tracker.waitForAll();
		}catch(InterruptedException exception){result=false;}
		width  = im.getWidth(null);
		height = im.getHeight(null);
		if(width  == -1){ width =32; result=false; }
		if(height == -1){ height=32; result=false; }
		px = new int[width*height];
		PixelGrabber pg;
		try
		{
			pg = new PixelGrabber(im, 0, 0, width, height, px, 0, width);
			pg.grabPixels();
		}catch(InterruptedException exception){result=false;}
		im.flush();
		size = width*height;
		for(n=0; n<size; n++)
		{
			if(px[n] >= 0)bTransparent = true;
		}
		return result;
	}

	/** awtC[WXV */
	public void update()
	{
		if(mi!=null)mi.newPixels();
	}

	/** `  ΐ`̑x͒xA``FbNsȂ */
	public void drawLine(int x1, int y1, int x2, int y2,int color)
	{
		int x,y,w,h,ad,n,m,k;
		if(y1==y2)// 
		{
			if(y1<0 || y1>=height)return;
			if(x1>x2){x=x1;x1=x2;x2=x;}
			if(x1<0)x1=0;if(x2>width )x2=width ;
			ad = y1*width + x1;
			for(x=x1;x<=x2;x++,ad++)px[ad] = color;
		}else
		if(x1==x2)// 
		{
			if(x1<0 || x1>=width)return;
			if(y1>y2){y=y1;y1=y2;y2=y;}
			if(y1<0)y1=0;if(y2>height)y2=height;
			ad = y1*width + x1;
			for(y=y1;y<=y2;y++,ad+=width)px[ad] = color;
		}else // ΐ
		{
			if(x1<0)x1=0;if(x1>=width )x1=width -1;
			if(x2<0)x2=0;if(x2>=width )x2=width -1;
			if(y1<0)y1=0;if(y1>=height)y1=height-1;
			if(y2<0)y2=0;if(y2>=height)y2=height-1;
			w = x2-x1; if(w<0)w=-w;
			h = y2-y1; if(h<0)h=-h;
			k = w>h ? w:h;
			for(n=0;n<=k;n++)
			{
				px[(y1*(k-n)+y2*n+k/2)/k*width + (x1*(k-n)+x2*n+k/2)/k] = color;
			}
		}
	}

	/** `hԂ */
	public void fillRect(int x, int y, int width, int height,int color)
	{
		int x1,y1,x2,y2;
		int ad,sk;
		x1 = x;
		y1 = y;
		x2 = x + width;
		y2 = y + height;
		if(x1>x2){x=x1;x1=x2;x2=x;}
		if(y1>y2){y=y1;y1=y2;y2=y;}
		if(x1<0)x1=0;if(x2>this.width )x2=this.width ;
		if(y1<0)y1=0;if(y2>this.height)y2=this.height;
		ad = y1*this.width+x1;
		sk = this.width-(x2-x1);
		for(y=y1;y<y2;y++,ad+=sk)
		{
			for(x=x1;x<x2;x++,ad++)
			{
				px[ad] = color;
			}
		}
	}

	/** NXm̕` */
	public void drawPixels(PixelBuffer32 src, int x, int y)
	{
		if(src==null)return;
		drawPixels(src, x, y, src.width, src.height, 0, 0);
	}

	/** NXm̕`@`挳ɑ΂``FbN͍sȂ */
	public void drawPixels(PixelBuffer32 src, int x1, int y1, int width, int height, int x2, int y2)
	{
		int cx,cy,ad1,ad2,sk1,sk2;
		if(src==null)return;
		int pxSrc[] = src.px;
		boolean bTransparent = src.bTransparent;
		if(x1<0){width +=x1; x2-=x1; x1=0;}
		if(y1<0){height+=y1; y2-=y1; y1=0;}
		if(x1+width  > this.width ) width  = this.width  - x1;
		if(y1+height > this.height) height = this.height - y1;
		if(width<0 || height<0)return;
		if(!bTransparent)
		{
			for(cy=0;cy<height;cy++)
			{
				System.arraycopy(pxSrc, (y2+cy)*src.width+x2, px, (y1+cy)*this.width+x1, width);
			}
		}else
		{
			ad1 = y1 * this.width + x1;
			ad2 = y2 * src .width + x2;
			sk1 = this.width - width;
			sk2 = src .width - width;
			for(cy=0;cy<height;cy++)
			{
				for(cx=0;cx<width;cx++,ad1++,ad2++)
				{
					if(pxSrc[ad2] < 0)px[ad1] = pxSrc[ad2];
				}
				ad1+=sk1;
				ad2+=sk2;
			}
		}
	}
}
